// #autoload
// #name = TrashRISFinder
// #config = TrashRISFinderOptions
// #category = ilys' Scripts
// #include = support/callback.cs
// #include = support/mission_callbacks.cs
// #include = support/player_support.cs
// #include = support/team_tracker.cs

$TrashRISFinder::SelectedRISOption = 0;
$TrashRISFinder::CustomRISNameText = "";
$TrashRISFinder::CustomClampNameText = "";
$TrashRISFinder::CustomSpikeNameText = "";
$TrashRISFinder::WPRIS = 1;

if(isFile("prefs/TrashRISFinder.cs")) exec("prefs/TrashRISFinder.cs");

package TrashRISFinder
{
	function clientCmdTaskInfo(%client, %aiObjtive, %team, %description, %targetName)
	{
		if($ItemUpdate)
		{
			if(%targetName $= "Deployable Station")
			{
				%createWP = 1;
				for(%i = 0; %i < $clientwaypoints.getCount(); %i++)
				{
					if($clientwaypoints.getObject(%i).invID == $ID) %createWP = 0;
				}
				if($TrashRISFinder::ShortRISNames) %name = "RIS";
				else if($TrashRISFinder::LongRISNames) %name = %targetName;
				else %name = $TrashRISFinder::CustomRISNameText;
				if(%createWP)
				{
					%target = createClientTarget($ID);
					%target.createWaypoint(%name);
					%target.invID = $ID;
					%target.invwaypoint = true;
					$ClientWaypoints.add(%target);
				}
			}
			$ItemUpdate = 0;
		}
		if(%client == teamtracker.myID && strstr(%description, "Repair") != -1) %description = " ";
		parent::clientCmdTaskInfo(%client, %aiObjtive, %team, %description, %targetName);
	}
	function clientCmdPotentialTask(%from, %description)
	{
		if(detag(%from) $= teamtracker.myName && strstr(%description, "Repair") != -1) return;
		parent::clientCmdPotentialTask(%from, %description);
	}
	function OptionsDlg::onWake(%this)
	{
		if (!$TrashRISBind)
		{
			$RemapName[$RemapCount] = "Toggle RISUpdate";
			$RemapCmd[$RemapCount]  = "ToggleWPRIS";
			$RemapCount++;
			$RemapName[$RemapCount] = "RISUpdate";
			$RemapCmd[$RemapCount]  = "WPRIS";
			$RemapCount++;
			$RemapName[$RemapCount] = "Clear Waypoints";
			$RemapCmd[$RemapCount]  = "ClearRISWaypoints";
			$RemapCount++;
			$TrashRISBind = true;
		}
		parent::onWake(%this);
	}
	function quit()
	{
		export("$TrashRISFinder::*", "prefs/TrashRISFinder.cs", false);
		parent::quit();
	}
	function PlayGui::onWake(%this)
	{
		Callback.add(MyTeamChanged, "ClearRISWaypoints");
		Callback.add(CallBackMsgGameOver, "ClearRISWaypoints");
		Callback.add(onUserClientDrop, "ClearRISWaypoints");
		Callback.add(onUserClientJoin, "ClearRISWaypoints");
		Callback.add(CallBackMsgTeamDeploySuccess, "PackDeployed");
		parent::onWake(%this);
	}
	function clientCmdSetBackpackHudItem(%num, %addItem)
	{
		parent::clientCmdSetBackpackHudItem(%num, %addItem);
		$pack = $BackpackHudData[%num, itemDataName];
	}
	function clientCmdChatMessage(%sender, %voice, %pitch, %msgString, %a1, %a2, %a3, %a4, %a5, %a6, %a7, %a8, %a9, %a10)
	{
		%msg = stripChars(detag(%msgString), "\cp\co\c1\c2\c3\c4\c5\c6\c7\c8\c9");
		if(strStr(%msg, "Inventory Station Deployed.") != -1) WPRIS();
		parent::clientCmdChatMessage(%sender, %voice, %pitch, %msgString, %a1, %a2, %a3, %a4, %a5, %a6, %a7, %a8, %a9, %a10);
	}
};
activatePackage(TrashRISFinder);

function PackDeployed()
{
	if($pack $= "InventoryDeployable") WPRIS();
}
function FindItems(%item)
{
	$ItemUpdate = 1;
	$MAX_OUTSTANDING_TASKS = 512;
	$ID = commanderTree.getTarget(%item,$SpamID);
	ServerConnection.sendTargetToServer($ID, "0 0 0");
	commandToServer('BuildClientTask','RepairObject',false);
	commandToServer('SendTaskToClient',PlayerList.getMyID(), false);
	$SpamID++;
	if($SpamID < commanderTree.getNumTargets(%item)) schedule(250,0,FindItems,%item);
	else $SpamID = 0;
}
function MakeFindRISCC()
{
	if(CommanderTree.getGroup() == CommanderTreeContainer.getObject(0) && canvas.getContent().getName() !$= "CommanderMapGui")
	{
		PlayGui.add(FindRISCC);
		FindRISCC.add(CommanderTree);
		CommanderTree.openCategory("DSupport",1);
		commandToServer('ScopeCommanderMap', true);
	}
}
function KillFindRISCC()
{
	if(CommanderTree.getGroup() == FindRISCC.getID())
	{
		PlayGui.remove(FindRISCC);
		CommanderTreeContainer.getObject(0).add(CommanderTree);
		commandToServer('ScopeCommanderMap', false);
	}
}
function ToggleWPRIS(%val)
{
	if(%val)
	{
		$TrashRISFinder::WPRIS = !$TrashRISFinder::WPRIS;
		%on = $TrashRISFinder::WPRIS ? "On" : "Off";
		clientCmdBottomPrint("WPRIS is now: "@%on, 2, 1);
	}
}
function WPRIS()
{
	if(!$TrashRISFinder::WPRIS) return;
	if($ItemUpdate) return;
	if(teamtracker.friendlyteamid == 0) return;
	MakeFindRISCC();
	schedule(250,0,WPRISSecond);
}
function WPRISSecond()
{
	FindItems(DSupport);
	schedule(250*commanderTree.getNumTargets(DSupport),0,KillFindRISCC);
}
function ClearRISWaypoints()
{
	$ItemUpdate = 0;
	for(%i = 0; %i < $clientwaypoints.getCount(); %i++)
	{
		if($clientwaypoints.getObject(%i).invwaypoint)
		{
			$clientwaypoints.getObject(%i).delete();
			%i--;
		}
	}
}
function TrashRISFinderOptions::onWake(%this)
{
	CustomRISText.setActive($TrashRISFinder::CustomRISNames);
	RISNamePopup.setSelected($TrashRISFinder::SelectedRISOption);
}
function RISNamePopup::onSelect(%this, %id, %text)
{
	if(%id == 0)
	{
		$TrashRISFinder::LongRISNames = 1;
		$TrashRISFinder::ShortRISNames = 0;
		$TrashRISFinder::CustomRISNames = 0;
		$TrashRISFinder::SelectedRISOption = %id;
		CustomRISText.setActive($TrashRISFinder::CustomRISNames);
	}
	else if(%id == 1)
	{
		$TrashRISFinder::LongRISNames = 0;
		$TrashRISFinder::ShortRISNames = 1;
		$TrashRISFinder::CustomRISNames = 0;
		$TrashRISFinder::SelectedRISOption = %id;
		CustomRISText.setActive($TrashRISFinder::CustomRISNames);
	}
	else if(%id == 2)
	{
		$TrashRISFinder::LongRISNames = 0;
		$TrashRISFinder::ShortRISNames = 0;
		$TrashRISFinder::CustomRISNames = 1;
		$TrashRISFinder::SelectedRISOption = %id;
		CustomRISText.setActive($TrashRISFinder::CustomRISNames);
	}
}
new GuiControl(FindRISCC)
{
	profile = "NewScrollCtrlProfile";
	horizSizing = "width";
	vertSizing = "height";
	position = "0 0";
	extent = "0 0";
};
new GuiControl(TrashRISFinderOptions) {
	profile = "GuiDefaultProfile";
	horizSizing = "center";
	vertSizing = "center";
	position = "0 0";
	extent = "195 90";
	visible = "1";
	new ShellFieldCtrl() {
		profile = "ShellFieldProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "4 4";
		extent = "185 80";
		minExtent = "16 18";
		visible = "1";
		new ShellPopupMenu(RISNamePopup) {
			profile = "ShellPopupProfile";
			horizSizing = "center";
			vertSizing = "bottom";
			position = "0 5";
			extent = "180 36";
			minExtent = "49 36";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Select Option";
			longTextBuffer = "1";
			maxLength = "255";
			maxPopupHeight = "500";
			buttonBitmap = "gui/shll_pulldown";
			rolloverBarBitmap = "gui/shll_pulldownbar_rol";
			selectedBarBitmap = "gui/shll_pulldownbar_act";
			noButtonStyle = "0";
		};
		new ShellTextEditCtrl(CustomRISText) {
			profile = "NewTextEditProfile";
			horizSizing = "center";
			vertSizing = "bottom";
			position = "0 35";
			extent = "180 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$TrashRISFinder::CustomRISNameText";
			helpTag = "0";
			longTextBuffer = "0";
			maxLength = "255";
			historySize = "0";
			password = "0";
			IRCName = "0";
			tabComplete = "0";
			deniedSound = "InputDeniedSound";
			glowOffset = "9 9";
		};
	};
};
RISNamePopup.add("Long RIS Names", 0);
RISNamePopup.add("Short RIS Names", 1);
RISNamePopup.add("Custom RIS Names", 2);
